#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>

#include <hpic.h>

int main(int argc, char *argv[]){

  size_t i,j,k;
  size_t nside;
  int order;
  int coord;
  size_t nang;
  size_t curpix;
  size_t pix1;
  size_t pix2;
  size_t n;
  size_t n1, n2, n3, n4;
  size_t row;
  size_t col;
  size_t incr;
  size_t progress;
  char name[HPIC_STRNL];
  char units[HPIC_STRNL];
  char filename[HPIC_STRNL];
  char extname[HPIC_STRNL];
  char comment[HPIC_STRNL];
  char creator[HPIC_STRNL];
  char command[HPIC_STRNL];
  char extnamecopy[HPIC_STRNL];
  char commentcopy[HPIC_STRNL];
  char creatorcopy[HPIC_STRNL];

  hpic_keys *keys;
  hpic_keys *keyscopy;  

  double theta, phi;
  double Ntheta, Nphi;
  double curtheta, curphi;
  double anginc;
  
  hpic_fltarr *maps;
  hpic *map;
  hpic_float *floatmap;
  hpic_int *intmap;
  hpic *copy;
  hpic_float *floatcopy;
  hpic_int *intcopy;
  hpic *copy2;
  hpic *copy3;

  hpic_float *data;
  hpic_float *errs;
  hpic_int *pix;
  hpic_int *hits;

  hpic_vec *vec;
  hpic_vec_float *floatvec;
  hpic_vec_int *intvec;
  hpic_vec *veccopy;
  hpic_vec_float *floatveccopy;
  hpic_vec_int *intveccopy;

  hpic_proj *proj;
  hpic_vec_index *headx;
  hpic_vec_index *heady;
  hpic_vec_index *tailx;
  hpic_vec_index *taily;
  hpic_vec_index *neighbors;

  size_t pixel;
    
  printf("\n   < Beginning HPIC Tests > \n\n");
  
  nside = 0;
  printf("hpictest:  checking hpic_nsidecheck at nside = %lu...  ",nside);
  fflush(stdout);
  if(hpic_nsidecheck(nside)){
    printf("failed\n");
  }else{
    printf("passed\n");
  }

  nside = 1;
  printf("hpictest:  checking hpic_nsidecheck at nside = %lu...  ",nside);
  fflush(stdout);
  if(hpic_nsidecheck(nside)){
    printf("failed\n");
  }else{
    printf("passed\n");
  }

  nside = 2;
  printf("hpictest:  checking hpic_nsidecheck at nside = %lu...  ",nside);
  fflush(stdout);
  if(hpic_nsidecheck(nside)){
    printf("failed\n");
  }else{
    printf("passed\n");
  }

  nside = 3;
  printf("hpictest:  checking hpic_nsidecheck at nside = %lu...  ",nside);
  fflush(stdout);
  if(hpic_nsidecheck(nside)){
    printf("failed\n");
  }else{
    printf("passed\n");
  }

  nside = 4;
  printf("hpictest:  checking hpic_nsidecheck at nside = %lu...  ",nside);
  fflush(stdout);
  if(hpic_nsidecheck(nside)){
    printf("failed\n");
  }else{
    printf("passed\n");
  }

  nside = 5;
  printf("hpictest:  checking hpic_nsidecheck at nside = %lu...  ",nside);
  fflush(stdout);
  if(hpic_nsidecheck(nside)){
    printf("failed\n");
  }else{
    printf("passed\n");
  }

  /*
  nside = 128;
  
  printf("hpictest:  checking RING row boundaries at nside = %lu...\n ",nside);
  fflush(stdout);
  phi = HPIC_PI/8.0;
  for(i=0;i<(12*nside*nside);i++){
    theta = 0.000001 * (double)i;
    ang2pix_ring(nside,theta,phi,&pix1);
    printf("  theta = %e --> pix %lu\n",theta,pix1);
  }
  printf("PASSED\n");
  */
  
  /*
  nside = 2;

  printf("Test 0 ---------\n");
  theta = 0.7648;
  phi =  2*HPIC_PI-0.00001;
  ang2pix_ring(nside, theta, phi, &pixel);      
  printf("Ring:  %g %g > %lu\n",theta,phi,pixel);
  ang2pix_nest(nside, theta, phi, &pixel);      
  printf("Nest:  %g %g > %lu\n",theta,phi,pixel);

  theta = 0.936045;

  printf("Test 1 ---------\n");
  phi = M_PI;
  ang2pix_ring(nside, theta, phi, &pixel);      
  printf("Ring:  %g %g > %lu\n",theta,phi,pixel);
  ang2pix_nest(nside, theta, phi, &pixel);      
  printf("Nest:  %g %g > %lu\n",theta,phi,pixel);

  printf("Test 2 ---------\n");
  phi =  2*HPIC_PI-0.00000001;
  ang2pix_ring(nside, theta, phi, &pixel);      
  printf("Ring:  %g %g > %lu\n",theta,phi,pixel);
  ang2pix_nest(nside, theta, phi, &pixel);      
  printf("Nest:  %g %g > %lu\n",theta,phi,pixel);

  phi =  6.28314;
  printf("Test 3 ---------\n");
  ang2pix_ring(nside, theta, phi, &pixel);      
  printf("Ring:  %g %g > %lu\n",theta,phi,pixel);
  ang2pix_nest(nside, theta, phi, &pixel);      
  printf("Nest:  %g %g > %lu\n",theta,phi,pixel);

  */
    
  nside = 128;
  
  printf("hpictest:  checking RING --> NEST --> RING at nside = %lu... ",nside);
  fflush(stdout);
  
  for(i=0;i<(12*nside*nside);i++){
  
    hpic_ring2nest(nside, i, &pix1);
    hpic_nest2ring(nside, pix1, &pix2);
  
    /*
    printf("Ring = %6lu  Nest = %6lu\n", i, pix1);
    printf("  Nest = %6lu  Ring = %6lu\n", pix1, pix2);
    fflush(stdout);
    */
  
    if(i != pix2){
      printf("FAILED\n");
      printf("hpictest:     at %lu -> %lu -> %lu, nside = %lu\n", i, pix1, pix2, nside);
      exit(1);
    }
  
  }
   
  printf("PASSED\n");
  
  
  printf("hpictest:  checking NEST --> RING --> NEST at nside = %lu... ",nside);
  fflush(stdout);
  for(i=0;i<(12*nside*nside);i++){
    hpic_nest2ring(nside,i,&pix1);
    hpic_ring2nest(nside,pix1,&pix2);
    if(i != pix2){
      printf("FAILED\n");
      printf("hpictest:     at NEST pixel %lu, nside = %lu\n",i,nside);
      exit(1);
    }
  }
  printf("PASSED\n");
  
  printf("hpictest:  checking RING --> ANG --> RING at nside = %lu... ",nside);
  fflush(stdout);
  
  for(i=0;i<(12*nside*nside);i++){
    hpic_pix2ang_ring(nside,i,&theta,&phi);
  
    /*
    printf("pix2ang_ring:  %lu --> (%e, %e)\n", i, theta, phi);
    fflush(stdout);
    */
  
    hpic_ang2pix_ring(nside,theta,phi,&pix1);
  
    /*
    printf("ang2pix_ring:  (%e, %e) --> %lu\n", theta, phi, pix1);
    fflush(stdout);
    */
  
    if(i != pix1){
      printf("FAILED\n");
      printf("hpictest:     at RING pixel %lu, nside = %lu\n",i,nside);
      exit(1);
    }
    
  }
    
  printf("PASSED\n");
  
  printf("hpictest:  checking NEST --> ANG --> NEST at nside = %lu... ",nside);
  fflush(stdout);
  
  for(i=0;i<(12*nside*nside);i++){
    
    hpic_pix2ang_nest(nside,i,&theta,&phi);
    /*
    printf("pix2ang_nest:  %lu --> (%e, %e)\n", i, theta, phi);
    fflush(stdout);
    */
    hpic_ang2pix_nest(nside,theta,phi,&pix1);
    /*
    printf("ang2pix_nest:  (%e, %e) --> %lu\n", theta, phi, pix1);
    fflush(stdout);
    */
    if(i != pix1){
      printf("FAILED\n");
      printf("hpictest:     at NEST pixel %lu, nside = %lu\n",i,nside);
      exit(1);
    }
    
  }
   
  printf("PASSED\n");
  
  
  /*-----------------------------------------------------------------------*/
  
  nside = 128;

  printf("hpictest:  checking pixel conversions at nside = %lu...  ",nside);
  fflush(stdout);

  for(i=0;i<(12*nside*nside);i++){
    hpic_pix2ang_nest(nside,i,&curtheta,&curphi);
    hpic_ang2pix_nest(nside,curtheta,curphi,&curpix);
    if(i != curpix){
      printf("FAILED\n");
      printf("hpictest:     at nested pixel %lu, nside = %lu\n",i,nside);
      exit(1);
    }
    hpic_pix2ang_ring(nside,i,&curtheta,&curphi);
    hpic_ang2pix_ring(nside,curtheta,curphi,&curpix);
    if(i != curpix){
      printf("FAILED\n");
      printf("hpictest:     at ring pixel %lu, nside = %lu\n",i,nside);
      exit(1);
    }
  }
  printf("PASSED\n");
  
  nside = 2;
  
  printf("hpictest:  testing angle extremes at nside = %lu...",nside);
  fflush(stdout);
  
  curtheta = HPIC_PI/2.0;
  curphi = 0.0;
  hpic_ang2pix_nest(nside,curtheta,curphi,&curpix);
  /*
  printf("hpictest:     theta = %e, phi = %e --> nested pixel %lu\n",curtheta,curphi,curpix);
  */
  hpic_ang2pix_ring(nside,curtheta,curphi,&curpix);
  /*
  printf("hpictest:     theta = %e, phi = %e --> ring pixel %lu\n",curtheta,curphi,curpix);
  */
  curtheta = HPIC_PI/2.0;
  curphi = HPIC_PI;
  hpic_ang2pix_nest(nside,curtheta,curphi,&curpix);
  /*
  printf("hpictest:     theta = %e, phi = %e --> nested pixel %lu\n",curtheta,curphi,curpix);
  */
  hpic_ang2pix_ring(nside,curtheta,curphi,&curpix);
  /*
  printf("hpictest:     theta = %e, phi = %e --> ring pixel %lu\n",curtheta,curphi,curpix);
  */
    
  printf("PASSED\n");
  
  /*-----------------------------------------------------------------------*/
  
  printf("hpictest:  testing basic map operations...  ");  
  fflush(stdout);

  nside = 128;

  order = HPIC_NEST;
  coord = HPIC_COORD_C;
  map = hpic_alloc(nside,order,coord,HPIC_AUTO);
  if(nside != hpic_nside_get(map)){
    printf("FAILED\n");
    printf("hpictest:    double nside integrity not preserved\n");
    exit(1);
  }
  if(order != hpic_order_get(map)){
    printf("FAILED\n");
    printf("hpictest:    double order integrity not preserved\n");
    exit(1);
  }
  if(coord != hpic_coord_get(map)){
    printf("FAILED\n");
    printf("hpictest:    double coord integrity not preserved\n");
    exit(1);
  }

  order = HPIC_RING;
  coord = HPIC_COORD_O;
  floatmap = hpic_float_alloc(nside,order,coord,HPIC_AUTO);
  if(nside != hpic_float_nside_get(floatmap)){
    printf("FAILED\n");
    printf("hpictest:    float nside integrity not preserved\n");
    exit(1);
  }
  if(order != hpic_float_order_get(floatmap)){
    printf("FAILED\n");
    printf("hpictest:    float order integrity not preserved\n");
    exit(1);
  }
  if(coord != hpic_float_coord_get(floatmap)){
    printf("FAILED\n");
    printf("hpictest:    float coord integrity not preserved\n");
    exit(1);
  }

  order = HPIC_NEST;
  coord = HPIC_COORD_G;
  intmap = hpic_int_alloc(nside,order,coord,HPIC_AUTO);
  if(nside != hpic_int_nside_get(intmap)){
    printf("FAILED\n");
    printf("hpictest:    int nside integrity not preserved\n");
    exit(1);
  }
  if(order != hpic_int_order_get(intmap)){
    printf("FAILED\n");
    printf("hpictest:    int order integrity not preserved\n");
    exit(1);
  }
  if(coord != hpic_int_coord_get(intmap)){
    printf("FAILED\n");
    printf("hpictest:    int coord integrity not preserved\n");
    exit(1);
  }

  strncpy(name,"double map",HPIC_STRNL);
  strncpy(units,"volts",HPIC_STRNL);
  hpic_name_set(map,name);
  hpic_units_set(map,units);
  if(strncmp(name,hpic_name_get(map),HPIC_STRNL)){
    printf("FAILED\n");
    printf("hpictest:    double name integrity not preserved\n");
    exit(1);
  }
  if(strncmp(units,hpic_units_get(map),HPIC_STRNL)){
    printf("FAILED\n");
    printf("hpictest:    double units integrity not preserved\n");
    exit(1);
  }

  strncpy(name,"float map",HPIC_STRNL);
  strncpy(units,"uK",HPIC_STRNL);
  hpic_float_name_set(floatmap,name);
  hpic_float_units_set(floatmap,units);
  if(strncmp(name,hpic_float_name_get(floatmap),HPIC_STRNL)){
    printf("FAILED\n");
    printf("hpictest:    float name integrity not preserved\n");
    exit(1);
  }
  if(strncmp(units,hpic_float_units_get(floatmap),HPIC_STRNL)){
    printf("FAILED\n");
    printf("hpictest:    float units integrity not preserved\n");
    exit(1);
  }

  strncpy(name,"int map",HPIC_STRNL);
  strncpy(units,"hits",HPIC_STRNL);
  hpic_int_name_set(intmap,name);
  hpic_int_units_set(intmap,units);
  if(strncmp(name,hpic_int_name_get(intmap),HPIC_STRNL)){
    printf("FAILED\n");
    printf("hpictest:    int name integrity not preserved\n");
    exit(1);
  }
  if(strncmp(units,hpic_int_units_get(intmap),HPIC_STRNL)){
    printf("FAILED\n");
    printf("hpictest:    int units integrity not preserved\n");
    exit(1);
  }
  printf("PASSED\n");

  printf("hpictest:  testing advanced map operations...\n");  
  fflush(stdout);

  hpic_setall(map,5.0);
  hpic_float_setall(floatmap,HPIC_NULL);
  hpic_int_setall(intmap,10);

  hpic_info_fprintf(stdout,map);
  hpic_float_info_fprintf(stdout,floatmap);
  hpic_int_info_fprintf(stdout,intmap);

  copy = hpic_copy(map);
  floatcopy = hpic_float_copy(floatmap);
  intcopy = hpic_int_copy(intmap);

  if(hpic_comp(map,copy) != 0){
    printf("hpictest:  double copy FAILED\n");
    exit(1);
  }
  if(hpic_float_comp(floatmap,floatcopy) != 0){
    printf("hpictest:  float copy FAILED\n");
    exit(1);
  }
  if(hpic_int_comp(intmap,intcopy) != 0){
    printf("hpictest:  int copy FAILED\n");
    exit(1);
  }

  printf("hpictest:  map operations PASSED\n");

  hpic_free(map);
  hpic_free(copy);
  hpic_float_free(floatmap);
  hpic_float_free(floatcopy);
  hpic_int_free(intmap);
  hpic_int_free(intcopy);
    
  /*-----------------------------------------------------------------------*/
  
  printf("hpictest:  testing vector operations...  ");  
  fflush(stdout);

  n = 100;

  vec = hpic_vec_alloc(n);
  floatvec = hpic_vec_float_alloc(n);
  intvec = hpic_vec_int_alloc(n);

  hpic_vec_setall(vec,1.23);
  hpic_vec_float_setall(floatvec,HPIC_NULL);
  hpic_vec_int_setall(intvec,HPIC_INT_NULL);

  veccopy = hpic_vec_copy(vec);
  floatveccopy = hpic_vec_float_copy(floatvec);
  intveccopy = hpic_vec_int_copy(intvec);

  for(i=0;i<n;i++){
    if(hpic_vec_get(vec,i) != hpic_vec_get(veccopy,i)){
      printf("FAILED\n");
      printf("hpictest:  double vec copy FAILED at element %lu\n",i);
      exit(1);
    }
    if(hpic_vec_float_get(floatvec,i) != hpic_vec_float_get(floatveccopy,i)){
      printf("FAILED\n");
      printf("hpictest:  float vec copy FAILED at element %lu\n",i);
      exit(1);
    }
    if(hpic_vec_int_get(intvec,i) != hpic_vec_int_get(intveccopy,i)){
      printf("FAILED\n");
      printf("hpictest:  int vec copy FAILED at element %lu\n",i);
      exit(1);
    }
  }
  printf("PASSED\n");

  hpic_vec_free(vec);
  hpic_vec_free(veccopy);
  hpic_vec_float_free(floatvec);
  hpic_vec_float_free(floatveccopy);
  hpic_vec_int_free(intvec);
  hpic_vec_int_free(intveccopy);
  
  /*-----------------------------------------------------------------------*/
  
  printf("hpictest:  testing conversion operations...  ");  
  fflush(stdout);

  nside = 32;
  order = HPIC_RING;
  coord = HPIC_COORD_C;
  map = hpic_alloc(nside,order,coord,HPIC_AUTO);  
  strncpy(name,"double map",HPIC_STRNL);
  strncpy(units,"volts",HPIC_STRNL);
  hpic_name_set(map,name);
  hpic_units_set(map,units);
  for(i=0;i<hpic_npix_get(map);i++){
    hpic_set(map,i,(double)i);
  }
  for(i=10;i<20;i++){
    hpic_set(map,i,HPIC_NULL);
  }
  copy = hpic_conv_xgrade(map,64);
  copy2 = hpic_conv_xgrade(copy,32);
  for(i=0;i<hpic_npix_get(map);i++){
    if(hpic_get(map,i) != hpic_get(copy2,i)){
      printf("FAILED\n");
      printf("RING prograde/degrade failed at pixel %lu: %e != %e\n",i,hpic_get(map,i),hpic_get(copy2,i));
      exit(1);
    }
  }
  hpic_free(copy);
  copy = hpic_copy(map);
  hpic_conv_nestcopy(copy);
  hpic_conv_ringcopy(copy);
  if(hpic_comp(map,copy) != 0){
    printf("FAILED\n");
    printf("hpictest:  double map order conversion (RING -> NEST -> RING) failed\n");
    exit(1);
  }
  hpic_free(map);
  hpic_free(copy);
  hpic_free(copy2);
  
  nside = 128;
  order = HPIC_NEST;
  coord = HPIC_COORD_C;
  map = hpic_alloc(nside,order,coord,HPIC_AUTO);  
  strncpy(name,"double map",HPIC_STRNL);
  strncpy(units,"volts",HPIC_STRNL);
  hpic_name_set(map,name);
  hpic_units_set(map,units);
  for(i=0;i<hpic_npix_get(map);i++){
    hpic_set(map,i,(double)i);
  }
  for(i=10;i<20;i++){
    hpic_set(map,i,HPIC_NULL);
  }
  copy = hpic_conv_xgrade(map,256);
  copy2 = hpic_conv_xgrade(copy,128);
  for(i=0;i<hpic_npix_get(map);i++){
    if(hpic_get(map,i) != hpic_get(copy2,i)){
      printf("FAILED\n");
      printf("hpictest:  NEST prograde/degrade failed at pixel %lu: %e != %e\n",i,hpic_get(map,i),hpic_get(copy2,i));
      exit(1);
    }
  }
  hpic_free(copy);
  copy = hpic_copy(map);
  hpic_conv_ringcopy(copy);
  hpic_conv_nestcopy(copy);
  if(hpic_comp(map,copy) != 0){
    printf("FAILED\n");
    printf("hpictest:  double map order conversion (NEST -> RING -> NEST) failed\n");
    exit(1);
  }
  hpic_free(map);
  hpic_free(copy);
  hpic_free(copy2);
  printf("PASSED\n");
  
  /*-----------------------------------------------------------------------*/
  
  printf("hpictest:  testing math operations...  ");  
  fflush(stdout);

  nside = 32;
  order = HPIC_NEST;
  coord = HPIC_COORD_C;
  map = hpic_alloc(nside,order,coord,HPIC_AUTO);  
  strncpy(name,"double map",HPIC_STRNL);
  strncpy(units,"volts",HPIC_STRNL);
  hpic_name_set(map,name);
  hpic_units_set(map,units);
  for(i=0;i<hpic_npix_get(map);i++){
    hpic_set(map,i,(double)i);
  }

  copy = hpic_copy(map);
  copy2 = hpic_copy(map);
  hpic_conv_ring(copy2);
  copy3 = hpic_conv_xgrade(copy2,64);
 
  hpic_add(copy,copy3,HPIC_INTERSECT);
  
  for(i=0;i<hpic_npix_get(copy);i++){
    if(hpic_get(copy,i) != 2*hpic_get(map,i)){
      printf("FAILED\n");
      printf("hpictest:  double map add failure\n");
      exit(1);
    }
  }

  for(i=10;i<hpic_npix_get(copy);i++){
    hpic_set(copy,i,HPIC_NULL);
  }

  hpic_subtract(copy,copy3,HPIC_INTERSECT);
  

  printf("PASSED\n");

  hpic_free(map);
  hpic_free(copy);
  hpic_free(copy2);
  hpic_free(copy3);
  
  

  /*-----------------------------------------------------------------------*/
  
  
  printf("hpictest:  testing location operations...  ");  
  fflush(stdout);

  nside = 128;
  order = HPIC_NEST;
  
  neighbors = hpic_vec_index_alloc(0);
  
  for(i=0;i<hpic_nside2npix(nside);i++){
    theta = hpic_loc_dist(nside,order,0,i);
    hpic_neighbors(nside, order, i, neighbors);
  }
  
  hpic_vec_index_free(neighbors);
  
  printf("PASSED\n");
  
  /*-----------------------------------------------------------------------*/
  
  printf("hpictest:  testing projection operations...  ");  
  fflush(stdout);

  nside = 128;
  order = HPIC_NEST;
  coord = HPIC_COORD_C;
  map = hpic_alloc(nside,order,coord,HPIC_AUTO);  
  hpic_name_set(map,"double map");
  hpic_units_set(map,"volts");
  
  for(i=0;i<hpic_npix_get(map);i++){
    hpic_set(map,i,10.0);
  }
  copy = hpic_copy(map);
  hpic_scale(copy,0.5);
  copy2 = hpic_copy(copy);

  proj = hpic_proj_alloc(1000,1000);
  hpic_proj_range_set(proj,HPIC_PI/3.0,HPIC_PI/2.0,HPIC_PI/6.0,HPIC_PI/5.0);
  hpic_proj_map(proj,map);
  headx = hpic_vec_index_alloc(1);
  heady = hpic_vec_index_alloc(1);
  tailx = hpic_vec_index_alloc(1);
  taily = hpic_vec_index_alloc(1);
  hpic_cmb_proj_QU(proj,copy,copy2,64,1.0,headx,heady,tailx,taily);
  hpic_proj_vecfield(proj,copy,copy2,64,10.0,headx,heady,tailx,taily);
  
  printf("PASSED\n");

  hpic_free(map);
  hpic_proj_free(proj);
  hpic_free(copy);
  hpic_free(copy2);
  hpic_vec_index_free(headx);
  hpic_vec_index_free(heady);
  hpic_vec_index_free(tailx);
  hpic_vec_index_free(taily);
  
  /*-----------------------------------------------------------------------*/
  
  printf("hpictest:  testing FITS operations...  ");  
  fflush(stdout);

  nside = 128;
  strncpy(filename,"test_cut.fits",HPIC_STRNL);
  strncpy(extname,"BOOMERanG_SkyMap",HPIC_STRNL);
  strncpy(creator,"hpictest",HPIC_STRNL);
  strncpy(comment,"B2K MAP",HPIC_STRNL);

  keys = hpic_keys_alloc();
  keyscopy = hpic_keys_alloc();
  
  hpic_keys_sadd(keys,"RELEASE","1.0","Data Release");
  hpic_keys_sadd(keys,"TARGET","Fake Map","Target of this map");
  hpic_keys_sadd(keys,"CHANNEL","B145W1","Data Channel");
  hpic_keys_iadd(keys,"SHOT",3,"Shot of this acquisition");
  hpic_keys_fadd(keys,"PI",3.14159,"This is PI");
  
  hpic_keys_printf(keys);
  
  sprintf(command,"rm -f %s",filename);
  system(command);

  floatmap = hpic_float_alloc(nside,HPIC_NEST,HPIC_COORD_C,HPIC_AUTO);
  data = hpic_float_alloc(nside,HPIC_NEST,HPIC_COORD_C,HPIC_AUTO);
  errs = hpic_float_alloc(nside,HPIC_NEST,HPIC_COORD_C,HPIC_AUTO);
  intmap = hpic_int_alloc(nside,HPIC_NEST,HPIC_COORD_C,HPIC_AUTO);
  hits = hpic_int_alloc(nside,HPIC_NEST,HPIC_COORD_C,HPIC_AUTO);
  pix = hpic_int_alloc(nside,HPIC_NEST,HPIC_COORD_C,HPIC_AUTO);
  hpic_float_name_set(floatmap,"DATA");
  hpic_float_units_set(floatmap,"Volts");
  hpic_int_name_set(intmap,"PIXELS");
  hpic_int_units_set(intmap,"");

  hpic_float_setall(floatmap,10.0);
  hpic_int_setall(intmap,HPIC_INT_NULL);
  for(i=0;i<12*nside*nside;i++){
    hpic_int_set(intmap,i,i);
  }

  maps = hpic_fltarr_alloc(1);
  hpic_fltarr_set(maps,0,floatmap);
  hpic_fits_cut_write(filename, creator, extname, comment, intmap, intmap, floatmap, maps, keys);
  hpic_fltarr_free(maps);

  maps = hpic_fltarr_alloc(1);
  hpic_fltarr_set(maps,0,data);
  hpic_fits_cut_read(filename, creator, extname, pix, hits, errs, maps, keyscopy);
  hpic_fltarr_free(maps);
  
  hpic_keys_printf(keyscopy);
  if(hpic_float_comp(data,floatmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  data integrity not preserved\n");
    exit(1);
  }
  if(hpic_float_comp(errs,floatmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  errs integrity not preserved\n");
    exit(1);
  }
  if(hpic_int_comp(pix,intmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  pix integrity not preserved\n");
    exit(1);
  }
  if(hpic_int_comp(hits,intmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  hits integrity not preserved\n");
    exit(1);
  }
  
  strncpy(filename,"test_single.fits",HPIC_STRNL);
  sprintf(command,"rm -f %s",filename);
  system(command);
  
  maps = hpic_fltarr_alloc(1);
  hpic_fltarr_set(maps,0,floatmap);
  hpic_fits_full_write(filename, creator, extname, comment, maps, keys);
  hpic_fltarr_free(maps);
  
  maps = hpic_fltarr_alloc(1);
  hpic_fltarr_set(maps,0,data);
  hpic_fits_full_read(filename, creator, extname, maps, keyscopy);
  hpic_fltarr_free(maps);
  
  hpic_keys_printf(keyscopy);
  if(hpic_float_comp(data,floatmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  data integrity not preserved\n");
    exit(1);
  }
  
  strncpy(filename,"test_TQU.fits",HPIC_STRNL);
  sprintf(command,"rm -f %s",filename);
  system(command);
  
  maps = hpic_fltarr_alloc(3);
  hpic_fltarr_set(maps,0,floatmap);
  hpic_fltarr_set(maps,1,floatmap);
  hpic_fltarr_set(maps,2,floatmap);
  hpic_fits_cut_write(filename, creator, extname, comment, intmap, intmap, floatmap, maps, keys);
  

  floatcopy = hpic_fits_read_one(filename, 0, creator, keyscopy);
  if(hpic_float_comp(floatcopy,floatmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  hpic_fits_read_one[0] integrity not preserved\n");
    exit(1);
  }
  hpic_keys_printf(keyscopy);
  hpic_float_free(floatcopy);
  floatcopy = hpic_fits_read_one(filename, 1, creator, keyscopy);
  if(hpic_float_comp(floatcopy,floatmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  hpic_fits_read_one[1] integrity not preserved\n");
    exit(1);
  }
  hpic_keys_printf(keyscopy);
  hpic_float_free(floatcopy);
  floatcopy = hpic_fits_read_one(filename, 2, creator, keyscopy);
  if(hpic_float_comp(floatcopy,floatmap) != 0){
    printf("FAILED\n");
    printf("hpictest:  hpic_fits_read_one[2] integrity not preserved\n");
    exit(1);
  }
  hpic_keys_printf(keyscopy);
  hpic_float_free(floatcopy);
    
  strncpy(filename,"test_full.fits",HPIC_STRNL);
  sprintf(command,"rm -f %s",filename);
  system(command);
  
  hpic_fits_full_write(filename, creator, extname, comment, maps, keys);
  hpic_fltarr_free(maps);
  

  hpic_keys_free(keys);
  hpic_keys_free(keyscopy);
  hpic_float_free(floatmap);
  hpic_float_free(data);
  hpic_float_free(errs);
  hpic_int_free(intmap);
  hpic_int_free(hits);
  hpic_int_free(pix);

  printf("PASSED\n");
  
  /*-----------------------------------------------------------------------*/
  printf("\n");
  return 0;
}
